# -*- coding: utf-8 -*-
"""
Created on Mon Jun 22 12:07:57 2015

@author: zah
"""
import os.path as osp
from pathlib import Path
import glob
import re


from jinja2 import Environment, FileSystemLoader,StrictUndefined

title = "PDF4LHC Combination method benchmarks"

env = Environment(loader=FileSystemLoader('.'), undefined=StrictUndefined)

template = env.get_template('report.lyx.template')

def make_comp(root, prefix='*'):

    root = Path(root)

    pcomp_vpng = sorted(root.glob(prefix + "violin*.png"))
    pcomp_vpdf = sorted(root.glob(prefix + "violin*.pdf"))

    pcomp_cpng = sorted(root.glob(prefix + "ci*.png"))
    pcomp_cpdf = sorted(root.glob(prefix + "ci*.pdf"))

    base = Path('..')

    comp = [{'violinpdf': base/violinpdf,
                'violinpng': base/violinpng,
                'cipdf': base/cipdf,
                'cipng': base/cipng,
                'cisource': cipng,
                'violinsource': violinpng,
                'obsname': re.sub("\W", '' ,cipng.name[cipng.name.index('ciplot')+7:-4])
                }
            for violinpdf, cipdf, violinpng, cipng in
            zip(pcomp_vpdf, pcomp_cpdf, pcomp_vpng, pcomp_cpng)]

    return comp

def break_corrname(name):
    pdf, medium, scalesr = name.name.split('_')
    pdf = pdf.upper()
    neig = int(medium[:3])
    scale = int(scalesr[:3])
    return pdf, neig, scale


def make_corrs(root, prefix='*'):
    root = Path(root)
    base = Path('..')
    for path in sorted(root.glob(prefix)):

        pdf, neig, scale = break_corrname(path)
        label = "Correlations for {pdf} {neig} at scale {scale}%".format(**locals())
        yield label, str(path)



mch_pdf_nlo =  glob.glob('plots/PDF/mch_nlo_*.pdf')
mch_pdf_nnlo = glob.glob('plots/PDF/NNLO/*')
#meta_pdf = glob.glob('plots/PDF/metav2_*.pdf')
meta_pdf = glob.glob('plots/PDF/metaAnn/meta_*.pdf')
meta_pdf_alt = glob.glob('plots/PDF/metaAlt/*')



mch_lumis_nlo = glob.glob('plots/lumis/mch_nlo_*.pdf')
mch_lumis_nnlo = glob.glob('plots/lumis/mch_nnlo_*.pdf')
meta_lumis = glob.glob('plots/lumis/meta*.pdf')
meta_lumis_alt = glob.glob('plots/lumimetaalt/meta*.pdf')

nnlo_pheno = make_comp('plots/pheno_new/NNLO', )
nlo_pheno = make_comp('plots/pheno_new/NLO')
meta_pheno = make_comp('plots/meta_ann_pheno')
meta_pheno_nlo = make_comp('plots/pheno_meta_nlo')
meta_pheno_alt = make_comp('plots/metaphenonew')
nlo_comp = make_comp('plots/nlo_comp')

nlo_cmc = make_comp('plots/CMCpheno', 'group_1_')
nnlo_cmc = make_comp('plots/CMCpheno', 'group_0_')

#ADD MORE COMP VARIABLES HERE


smpdf_higgs = make_comp('plots/smpdf_higgs')
smpdf_top = make_comp('plots/smpdf_top')

smpdf_W = make_comp('plots/smpdf_W')
smpdf_Z = make_comp('plots/smpdf_Z')

smpdf_ladder1 = make_comp('plots/ladder1')

cmc_corrs_nnlo = make_corrs("plots/cmccorrs/NNLO")
cmc_corrs_nlo = make_corrs("plots/cmccorrs/NLO")



with open('result.lyx', 'w') as f:
    f.write(template.render(**locals()))

